#ifndef NPSTAT_ABSINTERVALQUADRATURE1D_HH_
#define NPSTAT_ABSINTERVALQUADRATURE1D_HH_

/*!
// \file AbsIntervalQuadrature1D.hh
//
// \brief Base class for quadratures on the [-1, 1] interval
//
// Author: I. Volobouev
//
// November 2020
*/

namespace npstat {
    class AbsIntervalQuadrature1D
    {
    public:
        inline virtual ~AbsIntervalQuadrature1D() {}

        virtual unsigned npoints() const = 0;
        virtual void getAllAbscissae(long double* absc, unsigned len) const = 0;
        virtual void getAllWeights(long double* weights, unsigned len) const = 0;
    };
}

#endif // NPSTAT_ABSINTERVALQUADRATURE1D_HH_
