#ifndef NPSTAT_LAPACK_DOUBLE_H_
#define NPSTAT_LAPACK_DOUBLE_H_

#ifdef USE_LAPACK_QUAD

#ifdef _GLIBCXX_USE_FLOAT128
#undef _GLIBCXX_USE_FLOAT128
#endif

#include <quadmath.h>

typedef __float128 lapack_double;

#include "npstat/nm/std_quadmath.hh"
#include "npstat/nm/float128IO.hh"

#include <iostream>

inline std::ostream& operator<<(std::ostream& os, const lapack_double& x)
{
    char buf[128];
    quadmath_snprintf(buf, sizeof(buf), "%.36Qg", x);
    os << buf;
    return os;
}

#else

typedef double lapack_double;

#endif

#endif // NPSTAT_LAPACK_DOUBLE_H_
