#ifndef NPSTAT_CORRECTDENSITYESTIMATEGHU_HH_
#define NPSTAT_CORRECTDENSITYESTIMATEGHU_HH_

/*!
// \file correctDensityEstimateGHU.hh
//
// \brief Glad-Hjort-Ushakov correction for density estimates
//
// Author: I. Volobouev
//
// Sep 2019
*/

namespace npstat {
    /**
    // Normalize and correct a discretized density estimate which might
    // not be non-negative everywhere. The method comes from the paper by
    // Ingrid K. Glad, Nils Lid Hjort and Nikolai G. Ushakov,
    // Scandinavian Journal of Statistics, Vol. 30, No. 2 (2003), pp. 415-427.
    */
    void correctDensityEstimateGHU(
        const double* estimator, unsigned long len,
        double* corrected, unsigned long lenCorrected,
        double binSize);
}

#endif // NPSTAT_CORRECTDENSITYESTIMATEGHU_HH_
