#ifndef NPSTAT_RANDOMHISTOFILL1D_HH_
#define NPSTAT_RANDOMHISTOFILL1D_HH_

/*! 
// \file randomHistoFill1D.hh
//
// \brief Utilities for filling 1-d histograms with random samples
//
// Author: I. Volobouev
//
// September 2019
*/

#include "npstat/rng/AbsRandomGenerator.hh"
#include "npstat/stat/AbsDistribution1D.hh"

namespace npstat {
    template <class Histo>
    void randomHistoFill1D(Histo* h, AbsRandomGenerator& rng,
                           const AbsDistribution1D& distro,
                           unsigned long npoints);

    template <class Histo>
    void randomHistoFillC1D(Histo* h, AbsRandomGenerator& rng,
                            const AbsDistribution1D& distro,
                            unsigned long npoints);
}

#include "npstat/stat/randomHistoFill1D.icc"

#endif // NPSTAT_RANDOMHISTOFILL1D_HH_
