#ifndef NPSTAT_RANDOMHISTOFILLND_HH_
#define NPSTAT_RANDOMHISTOFILLND_HH_

/*! 
// \file randomHistoFillND.hh
//
// \brief Utilities for filling multivariate histograms with random samples
//
// Author: I. Volobouev
//
// September 2019
*/

#include "npstat/rng/AbsRandomGenerator.hh"
#include "npstat/stat/AbsDistributionND.hh"

namespace npstat {
    template <class Histo>
    void randomHistoFillND(Histo* h, AbsRandomGenerator& rng,
                           const AbsDistributionND& distro,
                           unsigned long npoints);

    template <class Histo>
    void randomHistoFillCND(Histo* h, AbsRandomGenerator& rng,
                            const AbsDistributionND& distro,
                            unsigned long npoints);
}

#include "npstat/stat/randomHistoFillND.icc"

#endif // NPSTAT_RANDOMHISTOFILLND_HH_
