#include <cmath>

#include "npstat/stat/scannedKSDistance.hh"

namespace npstat {
    double scannedKSDistance(const AbsDistribution1D& reference,
                             const AbsDistribution1D& compared,
                             const unsigned nScanPoints)
    {
        double d = 0.0;
        if (nScanPoints)
        {
            const double step = 1.0/nScanPoints;
            for (unsigned i=0; i<nScanPoints; ++i)
            {
                const double cdf = (i+0.5)*step;
                const double cdf2 = compared.cdf(reference.quantile(cdf));
                const double diff = std::abs(cdf2 - cdf);
                if (diff > d)
                    d = diff;
            }
        }
        return d;
    }
}
